Golgi_NaR_defs = "Golgi_NaR.m" ;
autoload ("Golgi_NaR" , Golgi_NaR_defs) ;
autoload ("Golgi_NaR_init" , Golgi_NaR_defs) ;
global celsius
celsius = 23;
Golgi_NaR_init ;
y0 = Golgi_NaR_init (-65) ;
global N ;
N = length (y0) ;
function is = Golgi_NaR_currents_odepkg (y)
  global N ;
  global i_NaR ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_NaR (t , s) ;
  is = [ t i_NaR ] ;
endfunction
function is = Golgi_NaR_currents_lsode (y)
  global N ;
  global i_NaR ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = Golgi_NaR (s , t) ;
  is = [ t i_NaR ] ;
endfunction
function ys = Golgi_NaR_vclamp_run1_odepkg (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  P = odeset ("RelTol" , reltol , "AbsTol" , abstol , "MaxStep" , 1 , "InitialStep" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  vinit = vchold ;
  y0 = Golgi_NaR_init (vinit)
  sol = ode2r (@Golgi_NaR , [ t0 t1 ] , y0 , P) ;
  ys = [ sol.x sol.y ] ;
  vinit = vcbase ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_NaR , [ t2 t3 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
  vinit = vchold ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@Golgi_NaR , [ t4 t5 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
endfunction ;
function ys = Golgi_NaR_vclamp_run1_lsode (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  lsode_options ("absolute tolerance" , abstol) ;
  lsode_options ("relative tolerance" , reltol) ;
  lsode_options ("integration method" , "bdf") ;
  lsode_options ("initial step size" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  thold0 = linspace (t0 , t1 , (t1-t0) /dt) ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  tclamp = linspace (t2 , t3 , (t3-t2) /dt) ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  thold1 = linspace (t4 , t5 , (t5-t4) /dt) ;
  vinit = vchold ;
  y0 = Golgi_NaR_init (vinit)
  y = lsode (@Golgi_NaR , y0 , thold0) ;
  ys = [ thold0' y ] ;
  vinit = vcbase ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_NaR , y0 , tclamp) ;
  ys = vertcat (ys , [ tclamp' y ]) ;
  vinit = vchold ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@Golgi_NaR , y0 , thold1) ;
  ys = vertcat (ys , [ thold1' y ]) ;
endfunction
function ilog = Golgi_NaR_vclamp_fn (N , dt , vchold , vchdur , vcbase , vcdur , vcinc , vcsteps)
  vc = vcbase ;
  ys = cell (1 , vcsteps) ;
  for i = 1:vcsteps
    y = Golgi_NaR_vclamp_run1_odepkg (N , dt , vchold , vchdur , vc , vcdur) ;
    ys (i) = y ;
    vc = vc + vcinc ;
  endfor ;
  ilog = cell (vcsteps , 1) ;
  for i = 1:vcsteps
    ilogv = [ ] ;
    n = size (ys {i}) (1) ;
    for j = 1:n
      next = Golgi_NaR_currents_odepkg (ys {i} (j , :)) ;
      ilogv = vertcat (ilogv , next) ;
    endfor ;
    ilog {i} = ilogv ;
  endfor ;
endfunction
global reltol abstol
reltol = 1e-06 ;
abstol = 1e-06 ;
dt = 0.001 ;
## i_NaR plot
i_NaR_index = 2 ;
global comp313_vchold comp313_vchdur comp313_vcbase comp313_vcbdur comp313_vcinc comp313_vcsteps
Golgi_NaR_ilog = Golgi_NaR_vclamp_fn (N , dt , comp313_vchold , comp313_vchdur , comp313_vcbase , comp313_vcbdur , comp313_vcinc , comp313_vcsteps) ;
subplot (1 , 3 , 1) ;
plot (Golgi_NaR_ilog{1}(:,1) , Golgi_NaR_ilog{1}(:,i_NaR_index) , Golgi_NaR_ilog{2}(:,1) , Golgi_NaR_ilog{2}(:,i_NaR_index) , Golgi_NaR_ilog{3}(:,1) , Golgi_NaR_ilog{3}(:,i_NaR_index) , Golgi_NaR_ilog{4}(:,1) , Golgi_NaR_ilog{4}(:,i_NaR_index) , Golgi_NaR_ilog{5}(:,1) , Golgi_NaR_ilog{5}(:,i_NaR_index) , Golgi_NaR_ilog{6}(:,1) , Golgi_NaR_ilog{6}(:,i_NaR_index) , Golgi_NaR_ilog{7}(:,1) , Golgi_NaR_ilog{7}(:,i_NaR_index) , Golgi_NaR_ilog{8}(:,1) , Golgi_NaR_ilog{8}(:,i_NaR_index) , Golgi_NaR_ilog{9}(:,1) , Golgi_NaR_ilog{9}(:,i_NaR_index)) ;
NaR_log = vertcat ([Golgi_NaR_ilog{1}(:,1),Golgi_NaR_ilog{1}(:,i_NaR_index)] , [Golgi_NaR_ilog{2}(:,1),Golgi_NaR_ilog{2}(:,i_NaR_index)] , [Golgi_NaR_ilog{3}(:,1),Golgi_NaR_ilog{3}(:,i_NaR_index)] , [Golgi_NaR_ilog{4}(:,1),Golgi_NaR_ilog{4}(:,i_NaR_index)] , [Golgi_NaR_ilog{5}(:,1),Golgi_NaR_ilog{5}(:,i_NaR_index)] , [Golgi_NaR_ilog{6}(:,1),Golgi_NaR_ilog{6}(:,i_NaR_index)] , [Golgi_NaR_ilog{7}(:,1),Golgi_NaR_ilog{7}(:,i_NaR_index)] , [Golgi_NaR_ilog{8}(:,1),Golgi_NaR_ilog{8}(:,i_NaR_index)] , [Golgi_NaR_ilog{9}(:,1),Golgi_NaR_ilog{9}(:,i_NaR_index)]) ;
save -ascii "NaR.dat" NaR_log ;
